"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CurvePointIntersector = void 0;
var matter_js_1 = require("matter-js");
var math_utils_1 = require("../../base/math_utils");
var CurvePointIntersector = /** @class */ (function () {
    function CurvePointIntersector() {
    }
    CurvePointIntersector.prototype.intersects = function (curve, point) {
        var curveStart = matter_js_1.Vector.create(curve.x0, curve.y0);
        var curveEnd = matter_js_1.Vector.create(curve.x, curve.y);
        var pointVec = matter_js_1.Vector.create(point.x, point.y);
        return (0, math_utils_1.vectorEquals)(curveStart, pointVec) || (0, math_utils_1.vectorEquals)(curveEnd, pointVec);
    };
    CurvePointIntersector.prototype.supportedCommandTypes = function () {
        return [["C", "S", "Q"], ["M"]];
    };
    return CurvePointIntersector;
}());
exports.CurvePointIntersector = CurvePointIntersector;
