import { BodyConfig } from "../physics/body/body_config";
import { Aggregator } from "../agregator/aggregator";
import { RenderBuilder } from "./render_builder";
export declare class PhysicBuilder {
    private readonly _aggregator;
    private readonly _svg;
    private readonly _plugins;
    constructor(aggregator: Aggregator, svg: HTMLElement);
    withGravity(gravity: {
        x: number;
        y: number;
    }): PhysicBuilder;
    withBorderCollider(): PhysicBuilder;
    withMouseInteraction(mouseForce: number): PhysicBuilder;
    createSvgBodies(config: BodyConfig): RenderBuilder;
    private createSvgData;
}
