"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderBuilder = void 0;
var debug_renderer_1 = require("../renderer/debug_renderer");
var production_renderer_1 = require("../renderer/production_renderer");
var RenderBuilder = /** @class */ (function () {
    function RenderBuilder(physics, svgData) {
        this._physics = physics;
        this._svgData = svgData;
    }
    RenderBuilder.prototype.startDebug = function () {
        var renderer = new debug_renderer_1.DebugRenderer();
        renderer.renderLoop(this._svgData, this._physics);
    };
    RenderBuilder.prototype.startProduction = function () {
        var renderer = new production_renderer_1.ProductionRenderer();
        renderer.renderLoop(this._svgData, this._physics);
    };
    return RenderBuilder;
}());
exports.RenderBuilder = RenderBuilder;
