"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rotatePointAroundCenterPoint = exports.findAngle = exports.vectorEquals = exports.multiplyVec = exports.length = exports.findCenterOfLine = exports.findDistanceVec = exports.findDistance = void 0;
var matter_js_1 = require("matter-js");
var findDistance = function (x, y, x1, y1) {
    return Math.sqrt(Math.pow(x - x1, 2) + Math.pow(y - y1, 2));
};
exports.findDistance = findDistance;
var findDistanceVec = function (p1, p2) {
    return (0, exports.findDistance)(p1.x, p1.y, p2.x, p2.y);
};
exports.findDistanceVec = findDistanceVec;
var findCenterOfLine = function (p1, p2) {
    return matter_js_1.Vector.create((p1.x + p2.x) / 2, (p1.y + p2.y) / 2);
};
exports.findCenterOfLine = findCenterOfLine;
var length = function (p) {
    return Math.sqrt(Math.pow(p.x, 2) + Math.pow(p.y, 2));
};
exports.length = length;
var multiplyVec = function (p1, p2) {
    return matter_js_1.Vector.create(p1.x * p2.x, p1.y * p2.y);
};
exports.multiplyVec = multiplyVec;
var vectorEquals = function (p1, p2) {
    return p1.x === p2.x && p1.y === p2.y;
};
exports.vectorEquals = vectorEquals;
var findAngle = function (x, y, x1, y1) {
    var Vx = x - x1;
    var Vy = y - y1;
    var radians;
    if (Vx || Vy) {
        radians = Math.atan2(Vy, Vx) - Math.PI;
    }
    else {
        radians = 0;
    }
    if (radians < 0) {
        radians += 2 * Math.PI;
    }
    return radians;
};
exports.findAngle = findAngle;
var rotatePointAroundCenterPoint = function (cx, cy, x, y, angle) {
    var cos = Math.cos(angle);
    var sin = Math.sin(angle);
    var nx = (cos * (x - cx)) + (sin * (y - cy)) + cx;
    var ny = (cos * (y - cy)) - (sin * (x - cx)) + cy;
    return { x: nx, y: ny };
};
exports.rotatePointAroundCenterPoint = rotatePointAroundCenterPoint;
