"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RelativeMousePosition = void 0;
var vector2d_1 = require("./vector2d");
var RelativeMousePosition = /** @class */ (function () {
    function RelativeMousePosition(element) {
        var _this = this;
        this._mousePosition = new vector2d_1.Vector2d(0, 0);
        this._element = element;
        document.addEventListener("mousemove", function (ev) {
            _this._mousePosition = new vector2d_1.Vector2d(ev.clientX, ev.clientY);
        });
    }
    Object.defineProperty(RelativeMousePosition.prototype, "position", {
        get: function () {
            var rect = this._element.getBoundingClientRect();
            var x = this._mousePosition.x - rect.left; // x position within the element.
            var y = this._mousePosition.y - rect.top; // y position within the element.
            return new vector2d_1.Vector2d(x, y);
        },
        enumerable: false,
        configurable: true
    });
    return RelativeMousePosition;
}());
exports.RelativeMousePosition = RelativeMousePosition;
