"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBoundingBox = exports.isOverlaping = void 0;
var vector2d_1 = require("./vector2d");
var isOverlaping = function (rect1, rect2) {
    return isPointInRectangle(rect2.bottomLeft, rect1) ||
        isPointInRectangle(new vector2d_1.Vector2d(rect2.bottomLeft.x, rect2.topRight.y), rect1) ||
        isPointInRectangle(new vector2d_1.Vector2d(rect2.topRight.x, rect2.bottomLeft.y), rect1) ||
        isPointInRectangle(rect2.topRight, rect1);
};
exports.isOverlaping = isOverlaping;
var isPointInRectangle = function (point, rectangle) {
    return rectangle.bottomLeft.x <= point.x && rectangle.topRight.x >= point.x &&
        rectangle.bottomLeft.y <= point.y && rectangle.topRight.y >= point.y;
};
var createBoundingBox = function (points) {
    var sortedX = __spreadArray([], points, true).sort(function (p1, p2) { return p1.x - p2.x; });
    var sortedY = __spreadArray([], points, true).sort(function (p1, p2) { return p1.y - p2.y; });
    var bottomLeftX = sortedX[0].x;
    var bottomLeftY = sortedY[0].y;
    var topRightX = sortedX[sortedX.length - 1].x;
    var topRightY = sortedY[sortedY.length - 1].y;
    return {
        bottomLeft: new vector2d_1.Vector2d(bottomLeftX, bottomLeftY),
        topRight: new vector2d_1.Vector2d(topRightX, topRightY)
    };
};
exports.createBoundingBox = createBoundingBox;
