import { Shape } from "./shape";
import { CurveToCommandMadeAbsolute, QuadraticCurveToCommandMadeAbsolute, SmoothCurveToCommandMadeAbsolute } from "svg-path-parser";
import { SvgData } from "../svg_data";
import { Bezier } from "bezier-js";
export declare class CurveShape implements Shape<CurveToCommandMadeAbsolute | SmoothCurveToCommandMadeAbsolute | QuadraticCurveToCommandMadeAbsolute> {
    code: 'C';
    private _curve;
    private _svgData;
    constructor(curve: CurveToCommandMadeAbsolute | SmoothCurveToCommandMadeAbsolute | QuadraticCurveToCommandMadeAbsolute, svgData: SvgData);
    get command(): CurveToCommandMadeAbsolute | SmoothCurveToCommandMadeAbsolute | QuadraticCurveToCommandMadeAbsolute;
    get svgData(): SvgData;
    get center(): {
        x: number;
        y: number;
    };
    get curvePoints(): {
        x: number;
        y: number;
    }[];
    get bezier(): Bezier;
}
