"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineShape = void 0;
var math_utils_1 = require("../math_utils");
var LineShape = /** @class */ (function () {
    function LineShape(line, svgData) {
        this.code = 'L';
        this._line = line;
        this._svgData = svgData;
    }
    Object.defineProperty(LineShape.prototype, "svgData", {
        get: function () {
            return this._svgData;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LineShape.prototype, "command", {
        get: function () {
            return this._line;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LineShape.prototype, "center", {
        get: function () {
            var cmd = this.command;
            return { x: (cmd.x0 + cmd.x) / 2, y: (cmd.y + cmd.y0) / 2 };
        },
        enumerable: false,
        configurable: true
    });
    LineShape.prototype.findAngle = function () {
        var cmd = this.command;
        return (0, math_utils_1.findAngle)(cmd.x, cmd.y, cmd.x0, cmd.y0);
    };
    LineShape.prototype.findLength = function () {
        return (0, math_utils_1.findDistance)(this.command.x, this.command.y, this.command.x0, this.command.y0);
    };
    return LineShape;
}());
exports.LineShape = LineShape;
