"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapCommandsToShape = void 0;
var line_shape_1 = require("./line_shape");
var point_shape_1 = require("./point_shape");
var curve_shape_1 = require("./curve_shape");
var mapCommandsToShape = function (commands, svgData) {
    return commands
        .filter(function (command) {
        return "MALTQSC".includes(command.code);
    })
        .map(function (command) {
        switch (command.code) {
            case 'M':
                {
                    var move = command;
                    return new point_shape_1.PointShape(move, svgData);
                }
            case 'L':
                {
                    var line = command;
                    return new line_shape_1.LineShape(line, svgData);
                }
            case 'C':
                {
                    var curve = command;
                    return new curve_shape_1.CurveShape(curve, svgData);
                }
            case 'Q':
                {
                    var curve = command;
                    return new curve_shape_1.CurveShape(curve, svgData);
                }
            case 'S':
                {
                    var curve = command;
                    return new curve_shape_1.CurveShape(curve, svgData);
                }
            default:
                {
                    throw new Error("cannot map command ".concat(command.code, " to shape"));
                }
        }
    });
};
exports.mapCommandsToShape = mapCommandsToShape;
