"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Vector2d = void 0;
// TODO: deprecated, replace with matterjs vector
var Vector2d = /** @class */ (function () {
    function Vector2d(x, y) {
        this._x = x;
        this._y = y;
    }
    Object.defineProperty(Vector2d.prototype, "x", {
        get: function () {
            return this._x;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Vector2d.prototype, "y", {
        get: function () {
            return this._y;
        },
        enumerable: false,
        configurable: true
    });
    Vector2d.prototype.unit = function () {
        var length = this.length();
        return new Vector2d(this._x / length, this._y / length);
    };
    Vector2d.prototype.opposite = function () {
        return new Vector2d(-this._x, -this._y);
    };
    Vector2d.prototype.multiply = function (length) {
        return new Vector2d(this.x * length, this.y * length);
    };
    Vector2d.prototype.multiplyV = function (v) {
        return new Vector2d(this.x * v.x, this.y * v.y);
    };
    Vector2d.prototype.divide = function (length) {
        return new Vector2d(this.x / length, this.y / length);
    };
    Vector2d.prototype.add = function (vector) {
        return new Vector2d(vector.x + this.x, vector.y + this.y);
    };
    Vector2d.prototype.deduct = function (vector) {
        return new Vector2d(this.x - vector.x, this.y - vector.y);
    };
    Vector2d.prototype.equals = function (vector) {
        return this.x === vector.x && this.y === vector.y;
    };
    Vector2d.prototype.length = function () {
        return Math.sqrt(Math.pow(this.x, 2) + Math.pow(this.y, 2));
    };
    Vector2d.prototype.distance = function (vector) {
        return Math.sqrt(Math.pow(this.x - vector.x, 2) + Math.pow(this.y - vector.y, 2));
    };
    Vector2d.prototype.crossProduct = function (p) {
        return (this.x * p.y) - (this.y * p.x);
    };
    Vector2d.prototype.toString = function () {
        return this._x + "_" + this._y;
    };
    Vector2d.random = function () {
        return new Vector2d(Math.random(), Math.random());
    };
    Vector2d.fromString = function (key) {
        var split = key.split("_");
        return new Vector2d(Number(split[0]), Number(split[1]));
    };
    return Vector2d;
}());
exports.Vector2d = Vector2d;
