"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugUI = void 0;
var DebugUI = /** @class */ (function () {
    function DebugUI(svg) {
        this._svgElem = svg;
    }
    DebugUI.prototype.clear = function () {
        var _a, _b;
        var circles = this._svgElem.getElementsByTagName("circle");
        for (var i = 0; i < circles.length; i++) {
            (_a = circles.item(i)) === null || _a === void 0 ? void 0 : _a.remove();
        }
        var lines = this._svgElem.getElementsByTagName("line");
        for (var i = 0; i < lines.length; i++) {
            (_b = lines.item(i)) === null || _b === void 0 ? void 0 : _b.remove();
        }
    };
    DebugUI.prototype.drawCharacterPoints = function (characterPoints) {
        var _this = this;
        characterPoints.forEach(function (point) {
            var color = "yellow";
            _this.drawCircle(point, color, 1);
        });
    };
    DebugUI.prototype.drawCircle = function (position, color, size) {
        var circle = document.createElementNS('http://www.w3.org/2000/svg', "circle");
        circle.setAttribute("cx", position.x.toFixed(0).toString());
        circle.setAttribute("cy", position.y.toFixed(0).toString());
        circle.setAttribute("r", size.toString());
        circle.setAttribute("fill", color);
        this._svgElem.appendChild(circle);
    };
    DebugUI.prototype.drawLine = function (p1, p2, color) {
        var line = document.createElementNS('http://www.w3.org/2000/svg', "line");
        line.setAttribute("x1", p1.x.toFixed(0).toString());
        line.setAttribute("y1", p1.y.toFixed(0).toString());
        line.setAttribute("x2", p2.x.toFixed(0).toString());
        line.setAttribute("y2", p2.y.toFixed(0).toString());
        line.setAttribute("stroke", color);
        line.setAttribute("stroke-width", "2");
        this._svgElem.appendChild(line);
    };
    return DebugUI;
}());
exports.DebugUI = DebugUI;
