"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractPathParser = void 0;
var AbstractPathParser = /** @class */ (function () {
    function AbstractPathParser() {
        this._charsCommands = [];
    }
    AbstractPathParser.prototype.serialize = function (updatePositions) {
        // update commands with new positions
        return this._charsCommands.map(function (charCmds, index) {
            var positions = charCmds.reduce(function (acc, cmd) { return acc.concat(cmd.positions); }, []);
            positions = updatePositions(positions, index);
            var positionIndex = 0;
            charCmds.forEach(function (cmd) {
                var updatedCmdPositions = positions.slice(positionIndex, positionIndex + cmd.numberOfPositions);
                cmd.positions = updatedCmdPositions;
                positionIndex += cmd.numberOfPositions;
            });
            return charCmds;
        })
            .reduce(function (serialized, character) {
            return serialized + character.map(function (cmd) { return cmd.serialize(); }).join(" ");
        }, "");
    };
    return AbstractPathParser;
}());
exports.AbstractPathParser = AbstractPathParser;
