"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClosePathBody = void 0;
var matter_js_1 = require("matter-js");
var command_utils_1 = require("../../base/command_utils");
var math_utils_1 = require("../../base/math_utils");
var ClosePathBody = /** @class */ (function () {
    function ClosePathBody(closeCmd) {
        this._closeCmd = closeCmd;
        // TODO: parametrize
        var height = 5;
        var p1 = matter_js_1.Vector.create(closeCmd.x, closeCmd.y);
        var p2 = matter_js_1.Vector.create(closeCmd.x0, closeCmd.y0);
        if (!(0, math_utils_1.vectorEquals)(p1, p2)) {
            var lineMidPoint = (0, command_utils_1.findCenterOfLineCommand)(closeCmd);
            var lineLength = (0, command_utils_1.findLengthOfLineCommand)(closeCmd);
            var lineAngle = (0, command_utils_1.findAngleOfLineCommand)(closeCmd);
            var body = matter_js_1.Bodies.rectangle(lineMidPoint.x, lineMidPoint.y, lineLength, height, {
                angle: lineAngle
            });
            this._bodies = [body];
        }
        else {
            this._bodies = [];
        }
    }
    Object.defineProperty(ClosePathBody.prototype, "bodies", {
        get: function () {
            return this._bodies;
        },
        enumerable: false,
        configurable: true
    });
    ClosePathBody.prototype.updateSvgCommand = function () {
        // For Z command don't update anything
    };
    return ClosePathBody;
}());
exports.ClosePathBody = ClosePathBody;
