"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DummyPhysics = void 0;
var vector2d_1 = require("../base/vector2d");
var DummyPhysics = /** @class */ (function () {
    function DummyPhysics() {
        this._directionMap = new Map();
    }
    DummyPhysics.prototype.init = function (aggregatedShapes) {
        var _this = this;
        aggregatedShapes.forEach(function (shapes, index) {
            var vec = vector2d_1.Vector2d.random().multiply(0.1);
            _this._directionMap.set(index, vec);
        });
    };
    DummyPhysics.prototype.update = function (aggregatedShapes, deltaTime) {
        var _this = this;
        aggregatedShapes.forEach(function (shapes, index) {
            var direction = _this._directionMap.get(index);
            shapes.forEach(function (shape) {
                switch (shape.command.code) {
                    case 'M':
                        {
                            var cmd = shape.command;
                            cmd.x += direction.x;
                            cmd.y += direction.y;
                            break;
                        }
                    case 'L':
                        {
                            var cmd = shape.command;
                            cmd.x += direction.x;
                            cmd.y += direction.y;
                            break;
                        }
                    case 'C':
                        {
                            var cmd = shape.command;
                            cmd.x += direction.x;
                            cmd.y += direction.y;
                            cmd.x1 += direction.x;
                            cmd.y1 += direction.y;
                            cmd.x2 += direction.x;
                            cmd.y2 += direction.y;
                            break;
                        }
                }
            });
        });
    };
    return DummyPhysics;
}());
exports.DummyPhysics = DummyPhysics;
