"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineBody = void 0;
var matter_js_1 = require("matter-js");
var command_utils_1 = require("../../../base/command_utils");
var LineBody = /** @class */ (function () {
    function LineBody(lineCmd, colliderSize) {
        this._lineCmd = lineCmd;
        var lineMidPoint = (0, command_utils_1.findCenterOfLineCommand)(lineCmd);
        var lineLength = (0, command_utils_1.findLengthOfLineCommand)(lineCmd);
        var lineAngle = (0, command_utils_1.findAngleOfLineCommand)(lineCmd);
        var p1 = matter_js_1.Vector.create(lineCmd.x, lineCmd.y);
        var p2 = matter_js_1.Vector.create(lineCmd.x0, lineCmd.y0);
        this._point = matter_js_1.Bodies.circle(lineCmd.x, lineCmd.y, 1, { isSensor: true });
        matter_js_1.Body.setDensity(this._point, 0);
        this._body = matter_js_1.Bodies.rectangle(lineMidPoint.x, lineMidPoint.y, lineLength, colliderSize, {
            angle: lineAngle
        });
        this._bodies = [this._point, this._body];
    }
    Object.defineProperty(LineBody.prototype, "bodies", {
        get: function () {
            return this._bodies;
        },
        enumerable: false,
        configurable: true
    });
    LineBody.prototype.updateSvgCommand = function () {
        this._lineCmd.x = this._point.position.x;
        this._lineCmd.y = this._point.position.y;
    };
    return LineBody;
}());
exports.LineBody = LineBody;
