import { Shape } from "../../../base/shape/shape";
import { Command } from "svg-path-parser";
import { Body, World } from "matter-js";
export declare abstract class PhysBody<T extends Shape<Command>> {
    protected _body: Body;
    protected _shape: T;
    constructor(shape: T, world: World);
    abstract createBody(shape: T): Body;
    abstract setPositionsToShape(): void;
    get body(): Body;
}
export declare const physBodyFactory: (shape: Shape<Command>, world: World) => PhysBody<Shape<Command>>;
