"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.physBodyFactory = exports.PhysBody = void 0;
var matter_js_1 = require("matter-js");
var line_body_1 = require("./line_body");
var point_body_1 = require("./point_body");
var PhysBody = /** @class */ (function () {
    function PhysBody(shape, world) {
        this._shape = shape;
        this._body = this.createBody(shape);
        matter_js_1.World.add(world, this._body);
    }
    Object.defineProperty(PhysBody.prototype, "body", {
        get: function () {
            return this._body;
        },
        enumerable: false,
        configurable: true
    });
    return PhysBody;
}());
exports.PhysBody = PhysBody;
var physBodyFactory = function (shape, world) {
    switch (shape.code) {
        case "L":
            {
                var line = shape;
                return new line_body_1.LineBody(line, world);
            }
        case "M":
            {
                var point = shape;
                return new point_body_1.PointBody(point, world);
            }
        default:
            {
                throw new Error("cannot create body for shape ".concat(shape.code));
            }
    }
};
exports.physBodyFactory = physBodyFactory;
