import { Vector2d } from "../base/vector2d";
import { AbstractSimulation } from "./simulation";
import { DebugUI } from "../debug";
import { RelativeMousePosition } from "./mouse";
export declare class PivotSimulation extends AbstractSimulation<{
    pivot: Vector2d | undefined;
    angleAcceleration: number;
}> {
    protected _debugUI: DebugUI;
    protected _mousePos: RelativeMousePosition;
    constructor(svg: HTMLElement);
    simulateWithData(data: {
        pivot: Vector2d;
        angleAcceleration: number;
    }, frameDuration: number, points: Vector2d[]): Vector2d[];
    private calculateTangentForce;
    private findPivot;
    private findCenterOfMass;
}
