"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LimitAngularVelocityPlugin = void 0;
var matter_js_1 = require("matter-js");
var LimitAngularVelocityPlugin = /** @class */ (function () {
    function LimitAngularVelocityPlugin(maxSpeed) {
        this._maxSpeed = maxSpeed;
    }
    LimitAngularVelocityPlugin.prototype.setup = function (svgData, engine, rootBodies) {
        var _this = this;
        var limitMaxSpeed = function () {
            rootBodies.forEach(function (body) {
                if (body.angularVelocity > _this._maxSpeed) {
                    matter_js_1.Body.setAngularVelocity(body, _this._maxSpeed);
                }
                if (body.angularVelocity < -_this._maxSpeed) {
                    matter_js_1.Body.setAngularVelocity(body, -_this._maxSpeed);
                }
            });
        };
        matter_js_1.Events.on(engine, 'beforeUpdate', limitMaxSpeed);
    };
    return LimitAngularVelocityPlugin;
}());
exports.LimitAngularVelocityPlugin = LimitAngularVelocityPlugin;
