"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MousePlugin = void 0;
var matter_js_1 = require("matter-js");
var MousePlugin = /** @class */ (function () {
    function MousePlugin(mouseForce) {
        this._mouseForce = mouseForce;
    }
    MousePlugin.prototype.setup = function (svgData, engine, rootBodies) {
        var _this = this;
        var world = engine.world;
        svgData.svg.addEventListener("mousemove", function (ev) {
            _this._mousePos = matter_js_1.Vector.create(ev.offsetX, ev.offsetY);
        });
        matter_js_1.Events.on(engine, 'afterUpdate', function () {
            if (_this._previousMousePos !== undefined && _this._mousePos !== undefined) {
                var bodies = matter_js_1.Query.point(matter_js_1.Composite.allBodies(world), _this._mousePos);
                bodies.forEach(function (body) {
                    var direction = matter_js_1.Vector.normalise(matter_js_1.Vector.sub(_this._mousePos, _this._previousMousePos));
                    matter_js_1.Body.applyForce(body, _this._mousePos, matter_js_1.Vector.mult(direction, _this._mouseForce));
                });
            }
            _this._previousMousePos = _this._mousePos;
        });
    };
    return MousePlugin;
}());
exports.MousePlugin = MousePlugin;
