"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollPlugin = void 0;
var matter_js_1 = require("matter-js");
var ScrollPlugin = /** @class */ (function () {
    function ScrollPlugin(force) {
        this._force = force;
    }
    ScrollPlugin.prototype.setup = function (svgData, physEngine, rootBodies) {
        var _this = this;
        var world = physEngine.world;
        window.onscroll = (function (ev) {
            _this._scrollPos = matter_js_1.Vector.create(window.scrollX, window.scrollY);
        });
        matter_js_1.Events.on(physEngine, 'afterUpdate', function () {
            if (_this._scrollPos !== undefined && _this._previousScrollPos !== undefined) {
                var bodies = matter_js_1.Composite.allBodies(world);
                bodies.forEach(function (body) {
                    var direction = matter_js_1.Vector.normalise(matter_js_1.Vector.sub(_this._scrollPos, _this._previousScrollPos));
                    matter_js_1.Body.applyForce(body, body.position, matter_js_1.Vector.mult(direction, _this._force));
                });
            }
            _this._previousScrollPos = _this._scrollPos;
        });
    };
    return ScrollPlugin;
}());
exports.ScrollPlugin = ScrollPlugin;
