import { Vector2d } from "../base/vector2d";
export declare const GRAVITY = 0.5;
export declare const SIMULATION_SPEED = 6;
export interface Simulation {
    simulate(index: number, frameDuration: number, points: Array<Vector2d>): Array<Vector2d>;
}
export declare abstract class AbstractSimulation<T> implements Simulation {
    private readonly _dataMap;
    private _dataCreate;
    constructor(dataCreate: () => T);
    simulate(index: number, frameDuration: number, points: Array<Vector2d>): Array<Vector2d>;
    protected abstract simulateWithData(characterData: T, frameDuration: number, points: Array<Vector2d>): Array<Vector2d>;
    private getOrCreateData;
}
