"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractSimulation = exports.SIMULATION_SPEED = exports.GRAVITY = void 0;
exports.GRAVITY = 0.5;
exports.SIMULATION_SPEED = 6;
var AbstractSimulation = /** @class */ (function () {
    function AbstractSimulation(dataCreate) {
        this._dataMap = new Map();
        this._dataCreate = dataCreate;
    }
    AbstractSimulation.prototype.simulate = function (index, frameDuration, points) {
        var data = this.getOrCreateData(index);
        return this.simulateWithData(data, frameDuration, points);
    };
    AbstractSimulation.prototype.getOrCreateData = function (index) {
        var data = this._dataMap.get(index);
        if (data === undefined) {
            data = this._dataCreate();
            this._dataMap.set(index, data);
        }
        return data;
    };
    return AbstractSimulation;
}());
exports.AbstractSimulation = AbstractSimulation;
