"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeCommand = void 0;
var serializeCommand = function (command) {
    switch (command.code) {
        case 'M':
            {
                var move = command;
                return "M ".concat(move.x.toFixed(2), " ").concat(move.y.toFixed(2));
            }
        case 'L':
            {
                var line = command;
                return "L ".concat(line.x.toFixed(2), " ").concat(line.y.toFixed(2));
            }
        case 'Z':
            {
                return "Z";
            }
        case 'C':
            {
                var curve = command;
                return "C ".concat(curve.x1.toFixed(2), " ").concat(curve.y1.toFixed(2), " ").concat(curve.x2.toFixed(2), " ").concat(curve.y2.toFixed(2), "  ").concat(curve.x.toFixed(2), " ").concat(curve.y.toFixed(2));
            }
        case 'S':
            {
                var curve = command;
                return "S ".concat(curve.x2.toFixed(2), " ").concat(curve.y2.toFixed(2), "  ").concat(curve.x.toFixed(2), " ").concat(curve.y.toFixed(2));
            }
        case 'Q':
            {
                var curve = command;
                return "Q ".concat(curve.x1.toFixed(2), " ").concat(curve.y1.toFixed(2), " ").concat(curve.x.toFixed(2), " ").concat(curve.y.toFixed(2));
            }
        default:
            {
                throw new Error("no serializer found for ".concat(command.code));
            }
    }
};
exports.serializeCommand = serializeCommand;
