"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CurveCurveIntersector = void 0;
var matter_js_1 = require("matter-js");
var math_utils_1 = require("../../base/math_utils");
var command_utils_1 = require("../../base/command_utils");
var bezier_js_1 = require("../../../bezierjs/bezier.js");
var CurveCurveIntersector = /** @class */ (function () {
    function CurveCurveIntersector() {
    }
    CurveCurveIntersector.prototype.intersects = function (curve1, curve2) {
        var curve1Start = matter_js_1.Vector.create(curve1.x0, curve1.y0);
        var curve1End = matter_js_1.Vector.create(curve1.x, curve1.y);
        var curve2Start = matter_js_1.Vector.create(curve2.x0, curve2.y0);
        var curve2End = matter_js_1.Vector.create(curve2.x, curve2.y);
        if ((0, math_utils_1.vectorEquals)(curve1Start, curve2Start) ||
            (0, math_utils_1.vectorEquals)(curve1Start, curve2End) ||
            (0, math_utils_1.vectorEquals)(curve1End, curve2Start) ||
            (0, math_utils_1.vectorEquals)(curve1End, curve2End)) {
            return true;
        }
        var bezier1 = new bezier_js_1.Bezier((0, command_utils_1.findCurvePoints)(curve1));
        var bezier2 = new bezier_js_1.Bezier((0, command_utils_1.findCurvePoints)(curve2));
        var result = bezier1.curveintersects([bezier1], [bezier2]);
        return result.length !== 0;
    };
    CurveCurveIntersector.prototype.supportedCommandTypes = function () {
        return [["C", "S", "Q"], ["C", "S", "Q"]];
    };
    return CurveCurveIntersector;
}());
exports.CurveCurveIntersector = CurveCurveIntersector;
