"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineCurveIntersector = void 0;
var bezier_js_1 = require("../../../bezierjs/bezier.js");
var matter_js_1 = require("matter-js");
var math_utils_1 = require("../../base/math_utils");
var command_utils_1 = require("../../base/command_utils");
var LineCurveIntersector = /** @class */ (function () {
    function LineCurveIntersector() {
    }
    LineCurveIntersector.prototype.intersects = function (curve, line) {
        var curveStart = matter_js_1.Vector.create(curve.x0, curve.y0);
        var curveEnd = matter_js_1.Vector.create(curve.x, curve.y);
        var lineStart = matter_js_1.Vector.create(line.x0, line.y0);
        var lineEnd = matter_js_1.Vector.create(line.x, line.y);
        if ((0, math_utils_1.vectorEquals)(curveStart, lineStart) ||
            (0, math_utils_1.vectorEquals)(curveStart, lineEnd) ||
            (0, math_utils_1.vectorEquals)(curveEnd, lineStart) ||
            (0, math_utils_1.vectorEquals)(curveEnd, lineEnd)) {
            return true;
        }
        var bezier = new bezier_js_1.Bezier((0, command_utils_1.findCurvePoints)(curve));
        return bezier.intersects({ p1: lineStart, p2: lineEnd }).length !== 0;
    };
    LineCurveIntersector.prototype.supportedCommandTypes = function () {
        return [["C", "S", "Q"], ["L", "Z"]];
    };
    return LineCurveIntersector;
}());
exports.LineCurveIntersector = LineCurveIntersector;
