"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinePointIntersector = void 0;
var LinePointIntersector = /** @class */ (function () {
    function LinePointIntersector() {
    }
    LinePointIntersector.prototype.intersects = function (line, point) {
        var a = { x: line.x, y: line.y };
        var b = { x: line.x0, y: line.y0 };
        var c = { x: point.x, y: point.y };
        var crossProduct = (c.y - a.y) * (b.x - a.x) - (c.x - a.x) * (b.y - a.y);
        // compare versus epsilon for floating point values, or != 0 if using integers
        if (Math.abs(crossProduct) > 1e-10) {
            return false;
        }
        var dotProduct = (c.x - a.x) * (b.x - a.x) + (c.y - a.y) * (b.y - a.y);
        if (dotProduct < 0) {
            return false;
        }
        var squaredLengthBA = (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
        return dotProduct <= squaredLengthBA;
    };
    LinePointIntersector.prototype.supportedCommandTypes = function () {
        return [["L", "Z"], ["M"]];
    };
    return LinePointIntersector;
}());
exports.LinePointIntersector = LinePointIntersector;
