"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AggregationNode = void 0;
var uuid_1 = require("uuid");
var AggregationNode = /** @class */ (function () {
    function AggregationNode(value, parent) {
        this._id = (0, uuid_1.v4)();
        this._parent = parent;
        this._value = value;
        this._children = [];
    }
    Object.defineProperty(AggregationNode.prototype, "id", {
        get: function () {
            return this._id;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AggregationNode.prototype, "value", {
        get: function () {
            return this._value;
        },
        enumerable: false,
        configurable: true
    });
    AggregationNode.prototype.addChild = function (value) {
        var node = new AggregationNode(value, this);
        node._parent = this;
        this._children.push(node);
        return node;
    };
    AggregationNode.prototype.addChildNode = function (node) {
        node._parent = this;
        this._children.push(node);
        return node;
    };
    AggregationNode.prototype.getChildrenRecursively = function () {
        var children = new Array(this);
        this._children.forEach(function (child) {
            child.getChildrenRecursively().forEach(function (subChild) {
                children.push(subChild);
            });
        });
        return children;
    };
    AggregationNode.prototype.getRoot = function () {
        if (this._parent === undefined) {
            return this;
        }
        return this._parent.getRoot();
    };
    return AggregationNode;
}());
exports.AggregationNode = AggregationNode;
