"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AggregatorBuilder = void 0;
var collision_aggregator_1 = require("../agregator/collision_aggregator");
var path_aggregator_1 = require("../agregator/path_aggregator");
var simulation_builder_1 = require("./simulation_builder");
var AggregatorBuilder = /** @class */ (function () {
    function AggregatorBuilder(svg) {
        this._svg = svg;
    }
    AggregatorBuilder.prototype.useCollisionAggregator = function () {
        return new simulation_builder_1.SimulationBuilder(new collision_aggregator_1.CollisionAggregator(), this._svg);
    };
    AggregatorBuilder.prototype.usePathAggregator = function () {
        return new simulation_builder_1.SimulationBuilder(new path_aggregator_1.PathAggregator(), this._svg);
    };
    AggregatorBuilder.prototype.useCustomAggregator = function (aggregator) {
        return new simulation_builder_1.SimulationBuilder(aggregator, this._svg);
    };
    return AggregatorBuilder;
}());
exports.AggregatorBuilder = AggregatorBuilder;
