import { BodyConfig } from "../physics/body/body_config";
import { Aggregator } from "../agregator/aggregator";
import { PhysicsPlugin } from "../physics/physics_plugin";
export declare class SimulationBuilder {
    private readonly _aggregator;
    private readonly _svg;
    private readonly _plugins;
    constructor(aggregator: Aggregator, svg: HTMLElement);
    withGravity(gravity: {
        x: number;
        y: number;
    }): SimulationBuilder;
    withBorderCollider(): SimulationBuilder;
    withMouseInteraction(mouseForce: number): SimulationBuilder;
    withScrollInteraction(scrollForce: number): SimulationBuilder;
    withDebugRenderer(): SimulationBuilder;
    withCustomPlugin(plugin: PhysicsPlugin): SimulationBuilder;
    withLimitVelocityPlugin(maxSpeed: number): this;
    withLimitAngularVelocityPlugin(maxSpeed: number): this;
    startSimulation(config: BodyConfig): void;
    private createSvgData;
}
