import { CommandMadeAbsolute } from "svg-path-parser";
import { AllCommandTypes } from "./command_mapper";
export declare class SvgData {
    private readonly _svg;
    private readonly _strokeWidth;
    private readonly _width;
    private readonly _height;
    private readonly _viewBox;
    private readonly _pathCommands;
    private readonly _aggregatedCommands;
    constructor(svg: HTMLElement, pathCommands: CommandMadeAbsolute[][], aggregatedCommands: AllCommandTypes[][]);
    get pathCommands(): CommandMadeAbsolute[][];
    get aggregatedCommands(): AllCommandTypes[][];
    get svg(): HTMLElement;
    get width(): number;
    get height(): number;
    get viewBox(): {
        minx: number;
        miny: number;
        width: number;
        height: number;
    } | undefined;
    get relativeStrokeWidth(): number;
}
