"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SvgData = void 0;
var SvgData = /** @class */ (function () {
    function SvgData(svg, pathCommands, aggregatedCommands) {
        this._svg = svg;
        // this._strokeWidth = Number(svg.getAttribute("stroke-width")!.toLowerCase().replace("px", ""));
        this._strokeWidth = 15;
        this._width = svg.clientWidth;
        this._height = svg.clientHeight;
        this._pathCommands = pathCommands;
        this._aggregatedCommands = aggregatedCommands;
        var viewBoxString = svg.getAttribute("viewBox");
        if (viewBoxString === null) {
            return;
        }
        var values = viewBoxString.split(/[ ,]/).filter(Boolean).map(Number);
        this._viewBox = { minx: values[0], miny: values[1], width: values[2], height: values[3] };
    }
    Object.defineProperty(SvgData.prototype, "pathCommands", {
        get: function () {
            return this._pathCommands;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "aggregatedCommands", {
        get: function () {
            return this._aggregatedCommands;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "svg", {
        get: function () {
            return this._svg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "width", {
        get: function () {
            return this._width;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "height", {
        get: function () {
            return this._height;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "viewBox", {
        get: function () {
            return this._viewBox;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SvgData.prototype, "relativeStrokeWidth", {
        // TODO: calculate
        get: function () {
            return this._strokeWidth;
        },
        enumerable: false,
        configurable: true
    });
    return SvgData;
}());
exports.SvgData = SvgData;
