"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.physBodyFactory = void 0;
var line_body_1 = require("./line_body");
var point_body_1 = require("./point_body");
var curve_body_1 = require("./curve_body");
var reflection_curve_body_1 = require("./reflection_curve_body");
var quadratic_curve_body_1 = require("./quadratic_curve_body");
var close_path_body_1 = require("./close_path_body");
var physBodyFactory = function (command, colliderSize) {
    switch (command.code) {
        case "L":
            {
                return new line_body_1.LineBody(command, colliderSize);
            }
        case "M":
            {
                return new point_body_1.PointBody(command);
            }
        case "C":
            {
                return new curve_body_1.CurveBody(command, colliderSize);
            }
        case "Q":
            {
                return new quadratic_curve_body_1.QuadraticCurveBody(command, colliderSize);
            }
        case "S":
            {
                return new reflection_curve_body_1.ReflectionCurveBody(command, colliderSize);
            }
        case "T":
            {
                throw new Error("T not supported yet!");
            }
        case "Z":
            {
                return new close_path_body_1.ClosePathBody(command);
            }
    }
};
exports.physBodyFactory = physBodyFactory;
