"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReflectionCurveBody = void 0;
var matter_js_1 = require("matter-js");
var abstract_curve_body_1 = require("./abstract_curve_body");
var ReflectionCurveBody = /** @class */ (function (_super) {
    __extends(ReflectionCurveBody, _super);
    function ReflectionCurveBody(curve, colliderSize) {
        var _this = _super.call(this) || this;
        _this._curve = curve;
        _this._bodies = _this.createInnerBodies(colliderSize, curve);
        _this._point1 = matter_js_1.Bodies.circle(curve.x, curve.y, 1, { isSensor: true, render: { fillStyle: "lightblue" } });
        matter_js_1.Body.setDensity(_this._point1, 0);
        _this._bodies.push(_this._point1);
        _this._point3 = matter_js_1.Bodies.circle(curve.x2, curve.y2, 1, { isSensor: true, render: { fillStyle: "lightblue" } });
        matter_js_1.Body.setDensity(_this._point3, 0);
        _this._bodies.push(_this._point3);
        return _this;
    }
    Object.defineProperty(ReflectionCurveBody.prototype, "bodies", {
        get: function () {
            return this._bodies;
        },
        enumerable: false,
        configurable: true
    });
    ReflectionCurveBody.prototype.updateSvgCommand = function () {
        this._curve.x = this._point1.position.x;
        this._curve.y = this._point1.position.y;
        this._curve.x2 = this._point3.position.x;
        this._curve.y2 = this._point3.position.y;
    };
    return ReflectionCurveBody;
}(abstract_curve_body_1.AbstractCurveBody));
exports.ReflectionCurveBody = ReflectionCurveBody;
