"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LimitVelocityPlugin = void 0;
var matter_js_1 = require("matter-js");
var LimitVelocityPlugin = /** @class */ (function () {
    function LimitVelocityPlugin(maxSpeed) {
        this._maxSpeed = maxSpeed;
    }
    LimitVelocityPlugin.prototype.setup = function (svgData, engine, rootBodies) {
        var _this = this;
        var limitMaxSpeed = function () {
            rootBodies.forEach(function (body) {
                if (body.velocity.x > _this._maxSpeed) {
                    matter_js_1.Body.setVelocity(body, { x: _this._maxSpeed, y: body.velocity.y });
                }
                if (body.velocity.x < -_this._maxSpeed) {
                    matter_js_1.Body.setVelocity(body, { x: -_this._maxSpeed, y: body.velocity.y });
                }
                if (body.velocity.y > _this._maxSpeed) {
                    matter_js_1.Body.setVelocity(body, { x: body.velocity.x, y: _this._maxSpeed });
                }
                if (body.velocity.y < -_this._maxSpeed) {
                    matter_js_1.Body.setVelocity(body, { x: -body.velocity.x, y: -_this._maxSpeed });
                }
            });
        };
        matter_js_1.Events.on(engine, 'beforeUpdate', limitMaxSpeed);
    };
    return LimitVelocityPlugin;
}());
exports.LimitVelocityPlugin = LimitVelocityPlugin;
