"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ViewColliderBorder = void 0;
var matter_js_1 = require("matter-js");
var ViewColliderBorder = /** @class */ (function () {
    function ViewColliderBorder() {
    }
    ViewColliderBorder.prototype.setup = function (svgData, engine, rootBodies) {
        var world = engine.world;
        var width = svgData.width;
        var height = svgData.height;
        var offsetX = 0;
        var offsetY = 0;
        var wallSize = 100;
        if (svgData.viewBox !== undefined) {
            var vbWidth = svgData.viewBox.width;
            var vbHeight = svgData.viewBox.height;
            var vbWhRatio = vbWidth < vbHeight ? (vbHeight / vbWidth) : (vbWidth / vbHeight);
            var whRatio = width < height ? (height / width) : (width / height);
            if (width < height) {
                if (vbWidth < vbHeight) {
                    height = vbHeight * (1 / whRatio) * vbWhRatio;
                    width = vbWidth;
                }
                else {
                    height = vbHeight * whRatio * vbWhRatio;
                    width = vbWidth;
                }
            }
            else {
                if (vbWidth < vbHeight) {
                    width = vbWidth * whRatio * vbWhRatio;
                    height = vbHeight;
                }
                else {
                    width = vbWidth * (1 / whRatio) * vbWhRatio;
                    height = vbHeight;
                }
            }
            offsetX = svgData.viewBox.minx - (width - vbWidth) / 2;
            offsetY = svgData.viewBox.miny - (height - vbHeight) / 2;
        }
        var bottom = matter_js_1.Bodies.rectangle((width / 2) + offsetX, height + (wallSize / 2) + offsetY, width, wallSize, { isStatic: true });
        matter_js_1.World.add(world, bottom);
        var top = matter_js_1.Bodies.rectangle((width / 2) + offsetX, -(wallSize / 2) + offsetY, width, wallSize, { isStatic: true });
        matter_js_1.World.add(world, top);
        var left = matter_js_1.Bodies.rectangle(-(wallSize / 2) + offsetX, (height / 2) + offsetY, wallSize, height, { isStatic: true });
        matter_js_1.World.add(world, left);
        var right = matter_js_1.Bodies.rectangle(width + (wallSize / 2) + offsetX, (height / 2) + offsetY, wallSize, height, { isStatic: true });
        matter_js_1.World.add(world, right);
    };
    return ViewColliderBorder;
}());
exports.ViewColliderBorder = ViewColliderBorder;
