"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugRenderer = void 0;
var renderer_1 = require("./renderer");
var DebugRenderer = /** @class */ (function () {
    function DebugRenderer() {
    }
    DebugRenderer.prototype.renderLoop = function (svgData, physics) {
        var svgClone = svgData.svg.cloneNode(true);
        svgClone.id = svgClone.id + "1";
        svgData.svg.parentElement.append(svgClone);
        var svgPaths = Array.prototype.slice.call(svgData.svg.getElementsByTagName('path'));
        this.updateFrame(svgData, physics, svgPaths);
    };
    DebugRenderer.prototype.updateFrame = function (svgData, physics, svgPaths) {
        var _this = this;
        physics.update(svgData.aggregatedCommands);
        svgData.pathCommands.forEach(function (commands, index) {
            var pathString = commands.map(renderer_1.serializeCommand).join(" ");
            svgPaths[index].setAttribute("d", pathString);
        });
        window.requestAnimationFrame(function (t) { return _this.updateFrame(svgData, physics, svgPaths); });
    };
    return DebugRenderer;
}());
exports.DebugRenderer = DebugRenderer;
