"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductionRenderer = void 0;
var renderer_1 = require("./renderer");
var ProductionRenderer = /** @class */ (function () {
    function ProductionRenderer() {
    }
    ProductionRenderer.prototype.renderLoop = function (svgData, physics) {
        var svgPaths = Array.prototype.slice.call(svgData.svg.getElementsByTagName('path'));
        this.updateFrame(svgData, physics, svgPaths);
    };
    ProductionRenderer.prototype.updateFrame = function (svgData, physics, svgPaths) {
        var _this = this;
        physics.update(svgData.aggregatedCommands);
        svgData.pathCommands.forEach(function (commands, index) {
            var pathString = commands.map(renderer_1.serializeCommand).join(" ");
            svgPaths[index].setAttribute("d", pathString);
        });
        window.requestAnimationFrame(function (t) { return _this.updateFrame(svgData, physics, svgPaths); });
    };
    return ProductionRenderer;
}());
exports.ProductionRenderer = ProductionRenderer;
